#ifndef Auto_h
#define Auto_h
/*
    GnuGoS60 - A Port of GNU Go to Series60/Symbian
    Copyright (C) 2006, 2007  Ian Dunbar

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdlib.h>
#include "ndMalloc.h"

class Auto {
public:
    Auto (void* p) {
        data = p;
    }

    ~Auto () {
        if (data) free (data);
    }
private:
    void *data;
};

#ifndef EKA2
#define AUTO(type, name, size)\
        type *name = (type*) malloc (sizeof(type) * (size));\
        Auto auto_##name (name);\
        const size_t sizeof_##name = (sizeof(type) * (size));
#else
#define AUTO(type, name, size)\
	type name [size];\
        const size_t sizeof_##name = (sizeof(type) * (size));
#endif

#if 1
#define AUTO0D(type, name)\
        type *p_##name = (type*) malloc (sizeof(type));\
        Auto auto_##name (p_##name);\
        const size_t sizeof_##name = (sizeof(type));\
        type &name = *p_##name;
#else
#define AUTO0D(type, name)\
	type name;\
        const size_t sizeof_##name = (sizeof(type));
#endif

#define AUTO1D(type, name, size)\
        AUTO(type, name, size);

#if 1
#define AUTO2D(type, name, size1, size2)\
        type **name = (type**) nd_malloc (sizeof(type), (size1), (size2), 0);\
        Auto auto_##name (name);\
        const size_t sizeof_##name = (sizeof(type) * (size1) * (size2));
#else
#define AUTO2D(type, name, size1, size2)\
	type name [size1][size2];\
        const size_t sizeof_##name = (sizeof(type) * (size1) * (size2));
#endif

#endif
