#ifndef Debug_h
#define Debug_h
/*
    GnuGoS60 - A Port of GNU Go to Series60/Symbian
    Copyright (C) 2006, 2007  Ian Dunbar

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifdef __cplusplus
extern "C" {
#endif

void DebugPrintf (const char *format, ...);

#if defined(_DEBUG) || defined (DEBUG) || defined (_DEBUG_)

#if defined(EKA2) || defined (WIN32)
#ifdef WIN32
#define DEBUG_PRINTF(args) REAL_DEBUG_PRINTF(##__FILE__, ##__LINE__, args)
#else
#define DEBUG_PRINTF(args) REAL_DEBUG_PRINTF(__FILE__, __LINE__, args)
#endif

#define REAL_DEBUG_PRINTF(file, line, args)\
	DebugPrintf ("%s: line %d: ", file, line);\
	DebugPrintf args;
#else
#define DEBUG_PRINTF(args) DebugPrintf args
#endif

#else 

#define DEBUG_PRINTF(args)

#endif

#ifdef __cplusplus
}
#endif

#endif
