/*
    GnuGoS60 - A Port of GNU Go to Series60/Symbian
    Copyright (C) 2006, 2007  Ian Dunbar

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <e32std.h>
#include <e32svr.h>
#include <stddef.h>
#include <stdarg.h>
#include <stdio.h>


extern "C" {
    int printf (const char *fmt, ...);
    int fprintf (FILE *file, const char *fmt, ...);
    void *memset (void *dest, int c, size_t count);
	void* realloc(void* aCell, size_t aSize);
    void *malloc (size_t size);
    void free (void *ptr);
}

int fprintf (FILE *file, const char *fmt, ...)
{
    if (stderr == file) return 0;
    if (stdout == file) return 0;

    va_list list;
    va_start(list, fmt);
    int ret = vfprintf (file, fmt, list);
    va_end(list);

    return ret;
}

int printf (const char *fmt, ...)
{
    return 0;
}

void *memset (void *dest, int c, size_t count)
{
    char *ptr = (char *) dest;
    for (size_t i = 0; i < count; ++i) {
        ptr [i] = c;
    }

    return dest;
}

void *malloc (size_t size)
{
#if 0
    TInt totalAllocSize;
    TInt cells = User::Heap().AllocSize (totalAllocSize);
    RDebug::Print (_L("malloc: Cells: 0x%08x, Total = 0x%08x, Alloc = 0x%08x"), cells, totalAllocSize, size);
#endif
    return User::AllocL (size);
}

void* realloc(void* aCell, size_t aSize)
{
	return User::ReAlloc(aCell, aSize);
}

void free (void *ptr)
{
#if 0
    TInt size = User::AllocLen (ptr);
#endif
    
    if (ptr) User::Free (ptr);

#if 0
    TInt totalAllocSize;
    TInt cells = User::Heap().AllocSize (totalAllocSize);
    RDebug::Print (_L("free:   Cells: 0x%08x, Total = 0x%08x, Alloc = 0x%08x"), cells, totalAllocSize, size);
#endif
}
