/*
    GnuGoS60 - A Port of GNU Go to Series60/Symbian
    Copyright (C) 2006, 2007  Ian Dunbar

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <e32std.h>
#include "Globals.h"

void init_globals ()
{
    struct globals *g = (struct globals *)Dll::Tls ();
    if (g) delete g;
    g = new (ELeave) struct globals ();
    Mem::FillZ (g, sizeof (*g));
    Dll::SetTls ((TAny*)g);

    g->gg_optind = 1;
    g->gg_opterr = 1;
    g->gg_optopt = '?';

    g->play_aftermath_current_color = EMPTY;

    g->fast_defense_liberty_mark = ~0U;
    g->dfa_board_size = -1;
    g->remaining_handicap_stones = -1;
    g->total_handicap_stones = -1;
    g->stones_on_board_stone_count_for_position = -1;
    {
        int i = 0;
        g->defend_lib_score              [i++] = -5;
        g->defend_lib_score              [i++] = -4;
        g->defend_lib_score              [i++] = 0;
        g->defend_lib_score              [i++] = 3;
        g->defend_lib_score              [i++] = 5;
        g->defend_lib_score              [i++] = 50;
    }
    {
        int i = 0;
        g->defend_not_adjacent_lib_score [i++] = 0;
        g->defend_not_adjacent_lib_score [i++] = 0;
        g->defend_not_adjacent_lib_score [i++] = 2;
        g->defend_not_adjacent_lib_score [i++] = 3;
        g->defend_not_adjacent_lib_score [i++] = 5;
    }
    {
        int i = 0;
        g->defend_capture_score          [i++] =  0;
        g->defend_capture_score          [i++] =  6;
        g->defend_capture_score          [i++] =  9;
        g->defend_capture_score          [i++] =  13;
        g->defend_capture_score          [i++] =  18;
        g->defend_capture_score          [i++] =  24;
    }
    {
        int i = 0;
        g->defend_atari_score            [i++] = 0;
        g->defend_atari_score            [i++] = 2;
        g->defend_atari_score            [i++] = 4;
        g->defend_atari_score            [i++] = 6;
        g->defend_atari_score            [i++] = 7;
        g->defend_atari_score            [i++] = 8;
    }
    {
        int i = 0;
        g->defend_save_score             [i++] = 0;
        g->defend_save_score             [i++] = 3;
        g->defend_save_score             [i++] = 6;
        g->defend_save_score             [i++] = 8;
        g->defend_save_score             [i++] = 10;
        g->defend_save_score             [i++] = 12;
    }
    {
        int i = 0;
        g->defend_open_score             [i++] = 0;
        g->defend_open_score             [i++] = 1;
        g->defend_open_score             [i++] = 2;
        g->defend_open_score             [i++] = 3;
        g->defend_open_score             [i++] = 4;
    }
    {
        int i = 0;
        g->attack_own_lib_score          [i++] = 10;
        g->attack_own_lib_score          [i++] = -4;
        g->attack_own_lib_score          [i++] = 2;
        g->attack_own_lib_score          [i++] = 3;
        g->attack_own_lib_score          [i++] = 4;
    }
    {
        int i = 0;
        g->attack_string_lib_score       [i++] = -5;
        g->attack_string_lib_score       [i++] = 2;
        g->attack_string_lib_score       [i++] = 3;
        g->attack_string_lib_score       [i++] = 7;
        g->attack_string_lib_score       [i++] = 10;
        g->attack_string_lib_score       [i++] = 19;
    }
    {
        int i = 0;
        g->attack_capture_score          [i++] = -4;
        g->attack_capture_score          [i++] = 4;
        g->attack_capture_score          [i++] = 10;
        g->attack_capture_score          [i++] = 15;
        g->attack_capture_score          [i++] = 20;
        g->attack_capture_score          [i++] = 25;
    }
    {
        int i = 0;
        g->attack_save_score             [i++] = 0;
        g->attack_save_score             [i++] = 10;
        g->attack_save_score             [i++] = 13;
        g->attack_save_score             [i++] = 18;
        g->attack_save_score             [i++] = 21;
        g->attack_save_score             [i++] = 24;
    }
    {
        int i = 0;
        g->attack_open_score             [i++] = 0;
        g->attack_open_score             [i++] = 0;
        g->attack_open_score             [i++] = 2;
        g->attack_open_score             [i++] = 4;
        g->attack_open_score             [i++] = 4;
    }
    g->defend_not_edge_score            = 5;
    g->attack_not_edge_score            = 1;
    g->attack_ko_score                  = -15;
    g->cannot_defend_penalty            = -20;
    g->safe_atari_score                 = 8;

    g->read_defend_db.fixed_for_size = -1;
    g->read_defend_db.fixed_anchor = 0;
    // TODO: g->read_defend_db.patterns = read_defend;
    g->read_defend_db.pdfa = NULL;

    g->read_attack_db.fixed_for_size = -1;
    g->read_attack_db.fixed_anchor = 0;
    // TODO: g->read_attack_db.patterns = read_attack;
    g->read_attack_db.pdfa = NULL;
    g->stones_on_board_stone_count_for_position = -1;


    g->worms_examined = -1;
    g->initial_influence_examined = -1;
    g->dragons_examined_without_owl = -1;
    g->dragons_examined = -1;
    g->initial_influence2_examined = -1;
    g->dragons_refinedly_examined = -1;
    g->global_owl_node_counter = 0;
    g->goal_worms_computed = 0;

    g->owl_stack_size = 0;
    g->owl_stack_pointer = 0;
    g->s_worms = 0;
    g->include_semeai_worms_in_eyespace = 0;

    g->aa_attackpat_db.fixed_for_size = -1;
    g->aa_attackpat_db.fixed_anchor = 0;
    // TODO: g->aa_attackpat_db.patterns = aa_attackpat;
    // TODO: g->aa_attackpat_db.pdfa = &(dfa_aa_attackpat);

    g->thrashing_dragon = NO_MOVE; /* Dead opponent's dragon trying to live. */
    g->hashflags = HASH_DEFAULT;

    /* Miscellaneous. */
    g->quiet             = 0;  /* minimal output */
    g->showstatistics    = 0;  /* print statistics */
    g->profile_patterns  = 0;  /* print statistics of pattern usage */
    g->allpats           = 0;  /* generate all patterns, even small ones */
    g->printworms        = 0;  /* print full data on each string */
    g->printmoyo         = 0;  /* print moyo board each move */
    g->printboard        = 0;  /* print board each move */
    g->loading           = 0;  /* TRUE if last loaded move comes from file */
    g->fusekidb          = 1;  /* use fuseki database */
    g->disable_fuseki    = 0;  /* do not generate fuseki moves */
    g->josekidb          = 1;  /* use fuseki database */
    g->showtime          = 0;  /* print time to find move */
    g->showscore         = 0;  /* print estimated score */
    g->level             = DEFAULT_LEVEL; /* strength; up to 10 supported */
    g->min_level         = 0;
    g->max_level         = gg_max(DEFAULT_LEVEL, 10);
    g->debug             = 0;  /* controls debug output */
    g->verbose           = 0;  /* trace level */
    g->outfilename [0] = '\0'; /* output file (-o option) */
    g->output_flags      = OUTPUT_DEFAULT; /* amount of output to outfile */
    g->limit_search      = 0;  /* limit search to a portion of the board */
    g->metamachine       = 0;  /* use metamachine_genmove */
    g->oracle_exists     = 0;  /* oracle is available for consultation   */

    g->disable_threat_computation = 0;
    g->disable_endgame_patterns   = 0;
    g->doing_scoring              = 0;

    g->chinese_rules       = 0;    /* ruleset choice for GMP connection */
    /* use experimental connection module */
    g->experimental_connections = EXPERIMENTAL_CONNECTIONS;
    /* use alternate connection reading algorithm */
    g->alternate_connections = ALTERNATE_CONNECTIONS;
    /* compute owl threats */
    g->owl_threats = OWL_THREATS; 
    /* use experimental owl extension (GAIN/LOSS) */
    g->experimental_owl_ext = EXPERIMENTAL_OWL_EXT;
    /* use experimental territory break-in module */
    g->experimental_break_in = USE_BREAK_IN;
    /* use central oriented influence */
    g->cosmic_gnugo = COSMIC_GNUGO;

    g->capture_all_dead    = 0;    /* capture all dead opponent stones */
    g->play_out_aftermath  = 0;    /* make everything unconditionally settled */
    g->resign_allowed      = 0;    /* resign hopeless games */
    g->large_scale         = 0;    /* search for large scale owl moves */

    g->play_mirror_go      = 0;    /* try to play mirror go if possible */
    g->mirror_stones_limit = -1;   /* but stop at this number of stones */

    g->gtp_version         = 2;    /* Use GTP version 2 by default. */

    g->dragon2 = NULL;

    g->slowest_time = 0.0;
    g->slowest_move = NO_MOVE;
    g->slowest_movenum = 0;
    g->total_time = 0.0;

    g->use_optimistic_territory = 0;
    g->minimum_value_weight  = 1.0;
    g->maximum_value_weight  = 1.0;
    g->invasion_malus_weight = 1.0;
    g->territorial_weight    = 1.0;
    g->strategical_weight    = 1.0;
    g->attack_dragon_weight  = 1.0;
    g->followup_weight       = 1.0;

    /* The board state itself. */
    g->board_size = DEFAULT_BOARD_SIZE; /* board size */
    g->allow_suicide = 0;  /* allow opponent to make suicide moves */
    g->count_variations  = 0;  /* used by decide_string */
    g->sgf_dump          = 0;  /* used by decide_string */
    g->sgf_dumptree = NULL;

    /* When to use pattern-base reading */
    g->defend_by_pattern = 0;
    g->attack_by_pattern = 1;

    g->attpat_db.fixed_for_size = -1;
    g->attpat_db.fixed_anchor = 0;
    // TODO: g->attpat_db.patterns = attpat;
    g->attpat_db.pdfa = NULL;

    g->influencepat_db.fixed_for_size = -1;
    g->influencepat_db.fixed_anchor = 0;
    // TODO: g->attpat_db.patterns = influencepat;
    g->influencepat_db.pdfa = NULL;

    g->barrierspat_db.fixed_for_size = -1;
    g->barrierspat_db.fixed_anchor = 0;
    // TODO: g->barrierspat_db.patterns = barrierspat;
    g->barrierspat_db.pdfa = NULL;
    
    g->reading_cache.max_size = MAX_READING_CACHE_SIZE;
    g->reading_cache.max_stackp = MAX_READING_CACHE_DEPTH;
    g->reading_cache.age_factor = 1.0;
    g->reading_cache.name = "reading cache";
    // TODO: g->reading_cache.compute_active_area = compute_active_reading_area;
    g->reading_cache.table = NULL;
    g->reading_cache.current_size = 0;
    g->reading_cache.last_purge_position_number = 1;

    g->connection_cache.max_size = MAX_CONNECTION_CACHE_SIZE;
    g->connection_cache.max_stackp = MAX_CONNECTION_CACHE_DEPTH;
    g->connection_cache.age_factor = 1.0;
    g->connection_cache.name = "connection cache";
    // TODO: g->connection_cache.compute_active_area = compute_active_connection_area;
    g->connection_cache.table = NULL;
    g->connection_cache.current_size = 0;
    g->connection_cache.last_purge_position_number = 1;

    g->breakin_cache.max_size = MAX_BREAKIN_CACHE_SIZE;
    g->breakin_cache.max_stackp = MAX_BREAKIN_CACHE_DEPTH;
    g->breakin_cache.age_factor = 1.0;
    g->breakin_cache.name = "breakin cache";
    // TODO: g->breakin_cache.compute_active_area = compute_active_breakin_area;
    g->breakin_cache.table = NULL;
    g->breakin_cache.current_size = 0;
    g->breakin_cache.last_purge_position_number = 1;

    g->owl_cache.max_size = MAX_OWL_CACHE_SIZE;
    g->owl_cache.max_stackp = MAX_OWL_CACHE_DEPTH;
    g->owl_cache.age_factor = 1.0;
    g->owl_cache.name = "owl cache";
    // TODO: g->owl_cache.compute_active_area = compute_active_owl_area;
    g->owl_cache.table = NULL;
    g->owl_cache.current_size = 0;
    g->owl_cache.last_purge_position_number = 1;

    g->conn_db.fixed_for_size = -1;
    g->conn_db.fixed_anchor = 0;
    // TODO: g->conn_db.patterns = conn;
    g->conn_db.pdfa = NULL;

    g->defpat_db.fixed_for_size = -1;
    g->defpat_db.fixed_anchor = 0;
    // TODO: g->defpat_db.patterns = defpat;
    g->defpat_db.pdfa = NULL;

    /* ================================================================ */
    /*                      static data structures                      */
    /* ================================================================ */

    g->trymove_counter = 0;

    {
        int i = 0;
        g->deltai [i++] = 1;
        g->deltai [i++] = 0;
        g->deltai [i++] = -1;
        g->deltai [i++] = 0;
        g->deltai [i++] = 1;
        g->deltai [i++] = -1;
        g->deltai [i++] = -1;
        g->deltai [i++] = 1;
    }
    {
        int i = 0;
        g->deltaj [i++] =  0;
        g->deltaj [i++] = -1;
        g->deltaj [i++] = 0;
        g->deltaj [i++] = 1;
        g->deltaj [i++] = -1;
        g->deltaj [i++] = -1;
        g->deltaj [i++] = 1;
        g->deltaj [i++] = 1;
    }
    {
        int i = 0;
        g->delta [i++] = NS;
        g->delta [i++] = -1;
        g->delta [i++] = -NS;
        g->delta [i++] = 1;
        g->delta [i++] = NS-1;
        g->delta [i++] = -NS-1;
        g->delta [i++] = -NS+1;
        g->delta [i++] = NS+1;
    }

    /* Pointer to influence data used during pattern matching. */
    g->current_influence = NULL;

    /* This curve determines how much influence is needed at least to claim
     * an intersection as territory, in dependence of the "center value".
     * (In the center, more effort is needed to get territory!)
     * The center value is at the moment defined as follows:
     * If d1, d2 are the distance to vertical and horizontal border, resp.,
     * with d1<d2, then
     * central = 3 * d1 + min(d2, 4)
     * So this is mainly a function of the distance to the border; the
     * distance to the second-nearest border gives a small correction of at
     * most 4. This distinguishes edge and corner positions.
     *
     * The values for intersections close to a corner or to the edge have
     * to be consistent such that standard corner enclosure etc. are
     * sufficient to claim territory. The center values are more arbitrary
     * suspect to tuning.
     */

    g->min_infl_for_territory.sections = 6;
    g->min_infl_for_territory.range_lowerbound = 0.0;
    g->min_infl_for_territory.range_upperbound = 24.0;
    {
        int i = 0;
        g->min_infl_for_territory.values [i++] = (float) 6.0;
        g->min_infl_for_territory.values [i++] = (float) 15.0;
        g->min_infl_for_territory.values [i++] = (float) 26.0;
        g->min_infl_for_territory.values [i++] = (float) 36.0;
        g->min_infl_for_territory.values [i++] = (float) 45.0;
        g->min_infl_for_territory.values [i++] = (float) 50.0;
        g->min_infl_for_territory.values [i++] = (float) 55.0;
    }

    /* Determines the territory correction factor in dependence of the ratio
     * ( influence of stronger color / min_infl_for_territory(intersection))
     */
    g->territory_correction.sections = 5;
    g->territory_correction.range_lowerbound = 0.0;
    g->territory_correction.range_upperbound = 1.0;
    {
        int i = 0;
        g->territory_correction.values [i++] = (float) 0.0;
        g->territory_correction.values [i++] = (float) 0.25;
        g->territory_correction.values [i++] = (float) 0.45;
        g->territory_correction.values [i++] = (float) 0.65;
        g->territory_correction.values [i++] = (float) 0.85;
        g->territory_correction.values [i++] = (float) 1.0;
    }

    /* If set, print influence map when computing this move. Purely for
     * debugging.
     */
    g->debug_influence = NO_MOVE;

    /* Assigns an id to all influence computations for reference in the
     * delta territory cache.
     */
    g->influence_id = 0;

    /* Cache of delta_territory_values. */
    g->territory_cache_position_number = -1;
    g->territory_cache_influence_id = -1;
    g->territory_cache_color = -1;

    g->endpat_db.fixed_for_size = -1;
    g->endpat_db.fixed_anchor = 0;
    // TODO: g->endpat_db.patterns = endpat;
    g->endpat_db.pdfa = NULL;

}

struct globals* global ()
{
    return (struct globals*) Dll::Tls ();
}
