#ifndef __GNUGO_APPUI_H__
#define __GNUGO_APPUI_H__

/*
    GnuGoS60 - A Port of GNU Go to Series60/Symbian
    Copyright (C) 2006, 2007  Ian Dunbar

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <eikspane.h> 

// Forward reference
class CgnugoAppView;
class GoGame;

/*! 
  @class CgnugoAppUi
  
  @discussion An instance of class CgnugoAppUi is the UserInterface part of the AVKON
  application framework for the gnugo example application
  */
#ifdef UIQ3
#include <qikappui.h>
class CgnugoAppUi : public CQikAppUi
#else
#include <aknappui.h>
class CgnugoAppUi : public CAknAppUi
#ifdef EKA2
, MEikStatusPaneObserver
#endif
#endif
    {
public:
/*!
  @function ConstructL
  
  @discussion Perform the second phase construction of a CgnugoAppUi object
  this needs to be public due to the way the framework constructs the AppUi 
  */
    void ConstructL();

/*!
  @function CgnugoAppUi
  
  @discussion Perform the first phase of two phase construction.
  This needs to be public due to the way the framework constructs the AppUi 
  */
    CgnugoAppUi();

/*!
  @function ~CgnugoAppUi
  
  @discussion Destroy the object and release all memory objects
  */
    ~CgnugoAppUi();

	virtual void HandleStatusPaneSizeChange ();

public: // from CAknAppUi
/*!
  @function HandleCommandL
  
  @discussion Handle user menu selections
  @param aCommand the enumerated code for the option selected
  */
    void HandleCommandL(TInt aCommand);
   
    void HandleResourceChangeL( TInt aType );
private:
/*! @var iAppView The application view */
    CgnugoAppView* iAppView;
    private:
    class GoGame *iGame;

    };


#endif // __GNUGO_APPUI_H__

