/*
    GnuGoS60 - A Port of GNU Go to Series60/Symbian
    Copyright (C) 2006, 2007  Ian Dunbar

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "gnugoApplication.h"
#include "Debug.h"

// Fix to unresolved ___pfnBkCheck with VC6++ introductory edition
// Stephane Vanlierde 17/08/1999
#ifdef __WINS__
#ifndef BKCHECK
#define BKCHECK
extern "C" void __pfnBkCheck() {}
#endif
#endif


#ifdef __UI_FRAMEWORKS_V2__
#include <eikstart.h>
// Create an application, and return a pointer to it
GLDEF_C CApaApplication* NewApplication()
	{
	return new CgnugoApplication;
	}


TInt E32Main()
	{
	return EikStart::RunApplication(NewApplication);	
	}

///////////////////////////////////////////////////////////////////////////////
//
// The following is required for wins on EKA1 (using the exedll target)
//
#if defined(__WINS__) && !defined(EKA2) && !defined(UIQ3)
TInt E32Dll(TDllReason)
	{
	return KErrNone;
	}
#endif

#else // __UI_FRAMEWORKS_V2__

// Create an application, and return a pointer to it
EXPORT_C CApaApplication* NewApplication()
  {
        DEBUG_PRINTF (("NewApplication"));
  return new CgnugoApplication;
  }

// DLL entry point, return that everything is ok
GLDEF_C TInt E32Dll(TDllReason reason)
  {
        DEBUG_PRINTF (("E32Dll reason (%d)", reason));
  return KErrNone;
  }

#endif // __UI_FRAMEWORKS_V2__

