/*
    GnuGoS60 - A Port of GNU Go to Series60/Symbian
    Copyright (C) 2006, 2007  Ian Dunbar

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "gnugoAppUi.h"
#include "gnugoDocument.h"
#include "Debug.h"
#include <sys\reent.h>
// Standard Symbian OS construction sequence
CgnugoDocument* CgnugoDocument::NewL(CEikApplication& aApp)
    {
        DEBUG_PRINTF (("CgnugoDocument::NewL"));

    CgnugoDocument* self = NewLC(aApp);
    CleanupStack::Pop(self);
    return self;
    }

CgnugoDocument* CgnugoDocument::NewLC(CEikApplication& aApp)
    {
        DEBUG_PRINTF (("CgnugoDocument::NewLC"));
    CgnugoDocument* self = new (ELeave) CgnugoDocument(aApp);
    CleanupStack::PushL(self);
    self->ConstructL();
    return self;
    }

void CgnugoDocument::ConstructL()
    {
        DEBUG_PRINTF (("CgnugoDocument::ConstructL"));
    }    

CgnugoDocument::CgnugoDocument(CEikApplication& aApp) : 
#ifdef UIQ3
	CQikDocument(aApp) 
#else
	CAknDocument(aApp) 
#endif
    {
        DEBUG_PRINTF (("CgnugoDocument::CgnugoDocument"));
    }

CgnugoDocument::~CgnugoDocument()
    {
	CloseSTDLIB();
    }

CEikAppUi* CgnugoDocument::CreateAppUiL()
    {
        DEBUG_PRINTF (("CgnugoDocument::CreateAppUiL"));
    // Create the application user interface, and return a pointer to it,
    // the framework takes ownership of this object
    CEikAppUi* appUi = new (ELeave) CgnugoAppUi;
    return appUi;
    }

